package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.PosicaoDeEstoquePage;

public class PosicaoDeEstoqueFlows {
    PosicaoDeEstoquePage posicaoDeEstoquePage;

    public PosicaoDeEstoqueFlows(){
        posicaoDeEstoquePage = new PosicaoDeEstoquePage();
    }

    public void GerarPosicaoDeEstoqueGrid(String descUnidade,String descAlmoxarifado,String descTipoDeCusto,String descProduto){
        posicaoDeEstoquePage.indexRelatorio();
       // posicaoDeEstoquePage.posicaoDeEstoque();
        //posicaoDeEstoquePage.repeteCabecalho();
       // posicaoDeEstoquePage.selecionarOpcao();
        posicaoDeEstoquePage.limparUnidade();
        posicaoDeEstoquePage.campoUnidade();
        posicaoDeEstoquePage.buttonbusca();
        posicaoDeEstoquePage.buscarUnidade(descUnidade);
        posicaoDeEstoquePage.selecionarUnidade();
        posicaoDeEstoquePage.limparPosicao();
        posicaoDeEstoquePage.campoCalendario();
        posicaoDeEstoquePage.selecionarData();
        posicaoDeEstoquePage.campoAlmoxarifado();
        posicaoDeEstoquePage.buscarAlmoxarifado(descAlmoxarifado);
        posicaoDeEstoquePage.selecionarAlmoxarifado();
        posicaoDeEstoquePage.limparTipoDeCusto();
        posicaoDeEstoquePage.buttonTipoDeCusto();
        posicaoDeEstoquePage.buscarTipoDeCusto(descTipoDeCusto);
        posicaoDeEstoquePage.selecionarTipoDeCusto();
        posicaoDeEstoquePage.nivelDeTotalizacao();
        posicaoDeEstoquePage.selecionarNivelDeTotalizacao();
        posicaoDeEstoquePage.ordenarPorNome();
        posicaoDeEstoquePage.selecionarOrdemPorNome();
        posicaoDeEstoquePage.campoProdutoInicial();
        posicaoDeEstoquePage.buscaProduto(descProduto);
        posicaoDeEstoquePage.selecionarProdutoInicial();
        posicaoDeEstoquePage.campoProdutoFinal();
        posicaoDeEstoquePage.buscarProdutoFinal(descProduto);
        posicaoDeEstoquePage.selecionarProdutoFinal();
        posicaoDeEstoquePage.buttonGrid();
        posicaoDeEstoquePage.validarGrid();
    }

    public void GerarPosicaoDeEstoquePDF(String descUnidade, String descAlmoxarifado, String descTipoDeCusto, String descProduto){
        posicaoDeEstoquePage.indexRelatorio();
        posicaoDeEstoquePage.selecionarRelatorio();
        posicaoDeEstoquePage.selecionarRepeteCabecalho();
        posicaoDeEstoquePage.selecionarOpcao();
        posicaoDeEstoquePage.limparUnidade();
        posicaoDeEstoquePage.campoUnidade();
        posicaoDeEstoquePage.buttonbusca();
        posicaoDeEstoquePage.buscarUnidade(descUnidade);
        posicaoDeEstoquePage.selecionarUnidade();
        posicaoDeEstoquePage.limparPosicao();
        posicaoDeEstoquePage.campoCalendario();
        posicaoDeEstoquePage.selecionarData();
        posicaoDeEstoquePage.campoAlmoxarifado();
        posicaoDeEstoquePage.buscarAlmoxarifado(descAlmoxarifado);
        posicaoDeEstoquePage.selecionarAlmoxarifado();
        posicaoDeEstoquePage.limparTipoDeCusto();
        posicaoDeEstoquePage.buttonTipoDeCusto();
        posicaoDeEstoquePage.buscarTipoDeCusto(descTipoDeCusto);
        posicaoDeEstoquePage.selecionarTipoDeCusto();
        posicaoDeEstoquePage.nivelDeTotalizacao();
        posicaoDeEstoquePage.selecionarNivelDeTotalizacao();
        posicaoDeEstoquePage.ordenarPorNome();
        posicaoDeEstoquePage.selecionarOrdemPorNome();
        posicaoDeEstoquePage.campoProdutoInicial();
        posicaoDeEstoquePage.buscaProduto(descProduto);
        posicaoDeEstoquePage.selecionarProdutoInicial();
        posicaoDeEstoquePage.campoProdutoFinal();
        posicaoDeEstoquePage.buscarProdutoFinal(descProduto);
        posicaoDeEstoquePage.selecionarProdutoFinal();
        posicaoDeEstoquePage.buttonGerarPDF();

    }
    public void GerarPosicaoDeEstoqueXLSX(String descUnidade, String descAlmoxarifado,String descTipoDeCusto, String descProduto){

        posicaoDeEstoquePage.indexRelatorio();
        posicaoDeEstoquePage.selecionarRelatorio();
        posicaoDeEstoquePage.selecionarRepeteCabecalho();
        posicaoDeEstoquePage.selecionarOpcao();
        posicaoDeEstoquePage.limparUnidade();
        posicaoDeEstoquePage.campoUnidade();
        posicaoDeEstoquePage.buttonbusca();
        posicaoDeEstoquePage.buscarUnidade(descUnidade);
        posicaoDeEstoquePage.selecionarUnidade();
        posicaoDeEstoquePage.limparPosicao();
        posicaoDeEstoquePage.campoCalendario();
        posicaoDeEstoquePage.selecionarData();
        posicaoDeEstoquePage.campoAlmoxarifado();
        posicaoDeEstoquePage.buscarAlmoxarifado(descAlmoxarifado);
        posicaoDeEstoquePage.selecionarAlmoxarifado();
        posicaoDeEstoquePage.limparTipoDeCusto();
        posicaoDeEstoquePage.buttonTipoDeCusto();
        posicaoDeEstoquePage.buscarTipoDeCusto(descTipoDeCusto);
        posicaoDeEstoquePage.selecionarTipoDeCusto();
        posicaoDeEstoquePage.nivelDeTotalizacao();
        posicaoDeEstoquePage.selecionarNivelDeTotalizacao();
        posicaoDeEstoquePage.ordenarPorNome();
        posicaoDeEstoquePage.selecionarOrdemPorNome();
        posicaoDeEstoquePage.campoProdutoInicial();
        posicaoDeEstoquePage.buscaProduto(descProduto);
        posicaoDeEstoquePage.selecionarProdutoInicial();
        posicaoDeEstoquePage.campoProdutoFinal();
        posicaoDeEstoquePage.buscarProdutoFinal(descProduto);
        posicaoDeEstoquePage.selecionarProdutoFinal();
        posicaoDeEstoquePage.buttonGerarXLSX();
    }


}
