package com.javaseleniumtemplate.pages;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
public class ProdutoPage extends PageBase {

        //Evento de loading da pagina:
            By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");

        //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:
            By iconFloatControl= By.xpath("//*[@class='zh-floating-control pos-bottom pos-right ui-draggable ui-draggable-handle']");
            By searchIcon = By.xpath("//*[@data-zh-id='zh-floating-control-custom-action-1']");
            By searchIcon2 = By.xpath("//*[@data-zh-id='zh-floating-control-handle']");
            By campoProcurarFloatControlProduto = By.xpath("//*[@class='floating-card-input']//*[@placeholder='Procurar']");
            By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");



        //ADICIONAR PRODUTO:
            By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='140777633833905578291108']");

        //DADOS DO PRODUTO_ESTOQUE:
            By CodigoArvoreSearch = By.xpath("//*[@data-zh-id='1407776338689942355877']//*[@zh-icon='no-border search']");
            By produtoEstoque = By.xpath("//span[text()='PRODUTO TESTE AUTOMATIZADOS']");//Nao precisa de data-zh-id
            By nome = By.xpath("//*[@zh-id='14077763383745162835884']");//Nao precisa de data-zh-id
            By UnidadeMedidaSearch = By.xpath("//*[@id='SGUNIDADE']//*[@zh-icon='no-border search']");
            By unidade = By.xpath("//*[@data-zh-field-name='DSUNIDADE']//*[.='Litro']");//Nao precisa de data-zh-id
            By tipoProduto = By.xpath("//*[@data-zh-id='1407776338347870136891']//*[@tabindex='0']");
            By estoqueValue = By.xpath("//*[@data-zh-id='1407776338347870136891']//*[@data-value='1']");
            By salvar = By.xpath("//*[@data-zh-id='14077763381057040872896']//*[.='Salvar']");

        //CONTAINER_ALERT:
            By containerAlert = By.xpath("//*[@class='zh-container-alert']");
            By okContainerAlert = By.xpath("//*[@data-zh-id='zh-footer-alert-button-0']");

        //ESTOQUE:
            By fatorCorrecao = By.xpath("//*[@zh-id='1407776338872539835905']");
            By pesoUnidade = By.xpath("//*[@zh-id='14077763381981617352904']");
           By embalagem = By.xpath("//*[@zh-id='14077763381039045682907']");
           By clicarLupaUnidade = By.xpath("//*[@data-zh-id='14077763382072433580909']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
            By btnSalvarEstoque = By.xpath("//*[@data-zh-id='14077763382889263416925']//*[.='Salvar']");


       //Excluir Produto:
            By nomeCadastroProdutoTipoEstoque = By.xpath("//span[text()='Produto Teste Automatizado Tipo Estoque']");//Nao precisa de data-zh-id

            By btnExcluir = By.xpath("//*[@data-zh-id='1407776338642110683189']");
            By textoNenhumRegistroEncontrado = By.xpath("//p[contains(.,'Nenhum registro foi encontrado')]");



    //Editar Produto:
            By btnEditar = By.xpath("//*[@data-zh-id='1407776338556374667894']");
            By codigoDeBarras = By.xpath("//*[@zh-id='14077763384163640479882']");
            By nomeCodificado = By.xpath("//*[@zh-id='14077763383986269413885']");
            By complementoDeNome = By.xpath("//*[@zh-id='14077763381847114992889']");
            By tamanho = By.xpath("//*[@zh-id='14077763383827371873400']");
            By informacoesAdicionaisDoProduto = By.xpath("//*[@zh-id='14077763383861560843890']");

    //Arvore de Produto
            By AdicionarProdutoArvoreEstoque = By.xpath("//*[@data-zh-id='125000397713589445781159']");
            By ProdutoNome = By.id("NMPRODUTO");
            By SalvarProduto = By.xpath("//span[text()='Salvar']");

            By GrupoOperadores = By.linkText("Grupo de Operadores");
            By AdicionarGrupoDeOperadores = By.xpath("//*[@data-zh-id='12500039771566821133747']");
            By BtnGrupoOperador = By.xpath("//div[@id='DSGRUPOPER']//*[@zh-icon='no-border search']");
            By Operador = By.xpath("//span[text()='ADMINISTRATIVO']");

            By CadastroProdutoEstoque = By.xpath("//div[@data-zh-id='12500039772051487735745']");
            By SelecionarOpcao = By.xpath("//ul[@class='list zh-new-select-list']/li[1]");


            By time = By.xpath("//span[text()='OK']");

    public void clicarBotaoAdicionar() {
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void codigoArvore() {
        waitForVisibilityOfElementLocated(CodigoArvoreSearch);
        click(CodigoArvoreSearch);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //DADOS DO PRODUTO
    public void campoBuscar() {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
    }

    public void digitarCodigoProduto(String codigoProduto) {
        sendKeys(campoProcurarFloatControl, codigoProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void selecionarProdutoEstoque() {
        waitForVisibilityOfElementLocated(produtoEstoque);
        click(produtoEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void buscarNomeProduto(String nomeProduto) {
        waitForVisibilityOfElementLocated(nome);
        sendKeys(nome, nomeProduto);
    }

    public void buscaUnidadeMedida() {
        waitForVisibilityOfElementLocated(UnidadeMedidaSearch);
        click(UnidadeMedidaSearch);
        waitForInvisibilityOfElementLocated(loadingWait);

    }

    public void clicarUnidade() {
        waitForVisibilityOfElementLocated(unidade);
        click(unidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void digitarUnidade(String unidadeMedida) {
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, unidadeMedida);
        waitForInvisibilityOfElementLocated(loadingWait);

    }

    public void clicarTipoProduto() {
        waitForVisibilityOfElementLocated(tipoProduto);
        click(tipoProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void valorEstoque() {
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(estoqueValue);
        click(estoqueValue);
    }

    public void clicarCampoEmbalagem(String valorEmbalagem) {
        waitForVisibilityOfElementLocated(embalagem);
        clearAndSendKeys(embalagem, valorEmbalagem);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarCampoUnidade() {
        waitForVisibilityOfElementLocated(clicarLupaUnidade);
        click(clicarLupaUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }


    //SALVAR:
    public void clicarSalvar() {
        waitForVisibilityOfElementLocated(salvar);
        click(salvar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //CONTAINER_ALERT
    public void clicarContainerAlert() {
        waitForVisibilityOfElementLocated(containerAlert);
        waitForVisibilityOfElementLocated(okContainerAlert);
        click(okContainerAlert);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    //FATOR DE CORREÇÂO
    public void fatorCorrecao(String valorFatorCorrecao) {
        waitForVisibilityOfElementLocated(fatorCorrecao);
        clearAndSendKeys(fatorCorrecao, valorFatorCorrecao);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarCampoPesoUnidade(String valorPesoUnidade) {
        waitForVisibilityOfElementLocated(pesoUnidade);
        clearAndSendKeys(pesoUnidade, valorPesoUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }


    //SALVAR
    public void clicarBotaoSalvar() {
        waitForVisibilityOfElementLocated(btnSalvarEstoque);
        click(btnSalvarEstoque);
        waitForElementByTime(time,30);
    }
    //PROCURANDO PRODUTO
    public void procurandoProduto(){
        waitForVisibilityOfElementLocated(iconFloatControl);
        click(iconFloatControl);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void buscarProduto(){
        waitForVisibilityOfElementLocated(searchIcon);
        click(searchIcon);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarProdutoNome(String nomeProduto){
        waitForVisibilityOfElementLocated(campoProcurarFloatControlProduto);
        sendKeys(campoProcurarFloatControlProduto,nomeProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void produtoCadastroEstoque(){
        waitForVisibilityOfElementLocated(nomeCadastroProdutoTipoEstoque);
        click(nomeCadastroProdutoTipoEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //EDITANDO PRODUTO
    public void clicarBotaoEditar(){
        waitForVisibilityOfElementLocated(btnEditar);
        click(btnEditar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //DADOS DO PRODUTO
    public void codigoBarras(String numeroDoCodigoDeBarras){
        waitForVisibilityOfElementLocated(codigoDeBarras);
        clearAndSendKeys(codigoDeBarras,numeroDoCodigoDeBarras);

    }
    public void nomeCodificado(String descricaoNomeCodificado){
        waitForVisibilityOfElementLocated(codigoDeBarras);
        clearAndSendKeys(nomeCodificado,descricaoNomeCodificado);
    }
    public void complementoNome(String descricaoComplementoDeNome){
        waitForVisibilityOfElementLocated(complementoDeNome);
        clearAndSendKeys(complementoDeNome,descricaoComplementoDeNome);
    }
    public void inserirDescricaoTamanho(String descricaoTamanho){
        waitForVisibilityOfElementLocated(tamanho);
        clearAndSendKeys(tamanho,descricaoTamanho);
    }
    public void informacoesAdicionaisProduto(String descricaoInformacoesAdicionaisDoProduto){
        waitForVisibilityOfElementLocated(informacoesAdicionaisDoProduto);
        clearAndSendKeys(informacoesAdicionaisDoProduto,descricaoInformacoesAdicionaisDoProduto);
    }

    //Excluir Produto
    public void cadastroTipoEstoque(){
        waitForVisibilityOfElementLocated(nomeCadastroProdutoTipoEstoque);
        click(nomeCadastroProdutoTipoEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //exluindo produto
    public void clicarBotaoExcluir(){
        waitForVisibilityOfElementLocated(btnExcluir);
        click(btnExcluir);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    /*public void inserirBuscaCampoProduto(){
        waitForVisibilityOfElementLocated(campoProcurarFloatControlProduto);
        clear(campoProcurarFloatControlProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

    }*/
    //CONFERINDO EXCLUSAO PRODUTO
public void buscarProdutoExcluido(){
    waitForVisibilityOfElementLocated(searchIcon2);
    click(searchIcon2);
    waitForInvisibilityOfElementLocated(loadingWait);
}
public  void  textoNaoEncontrado(String mensagemFinal){


    waitForElementWithoutClickable(textoNenhumRegistroEncontrado);
    clickWithText(textoNenhumRegistroEncontrado,mensagemFinal);
}

    // Arvore de Produto

    public void adicionarProdutoArvore(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(AdicionarProdutoArvoreEstoque);
        click(AdicionarProdutoArvoreEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //nome
    public void nomeProduto(String campoProdutoNome){
        waitForVisibilityOfElementLocated(ProdutoNome);
        sendKeys(ProdutoNome,campoProdutoNome);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    //grupo de operadores
    public void grupoOperadores(){
        waitForVisibilityOfElementLocated(GrupoOperadores);
        click(GrupoOperadores);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void adicionarGrupoOperadores(){
        waitForVisibilityOfElementLocated(AdicionarGrupoDeOperadores);
        click(AdicionarGrupoDeOperadores);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void clicarBotaoGrupoOperador(){
        waitForVisibilityOfElementLocated(BtnGrupoOperador);
        click(BtnGrupoOperador);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void buscarOperador(String campoOperador){
        sendKeys(campoProcurarFloatControl,campoOperador);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void selecionarOperador(){
        waitForVisibilityOfElementLocated(Operador);
        click(Operador);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
 public void clicarCadastroProduto() {
     waitForVisibilityOfElementLocated(CadastroProdutoEstoque);
     click(CadastroProdutoEstoque);
     waitForInvisibilityOfElementLocated(loadingWait);
 }
 public void selecionarOpcao(){
     waitForVisibilityOfElementLocated(SelecionarOpcao);
     click(SelecionarOpcao);
     waitForInvisibilityOfElementLocated(loadingWait);
 }

 public void salvarProduto(){
      waitForVisibilityOfElementLocated(SalvarProduto);
     click(SalvarProduto);
     waitForInvisibilityOfElementLocated(loadingWait);
 }

    }



