package com.javaseleniumtemplate.tests.naocontrolaalmoxarifado;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.naocontrolaalmoxarifado.FecharDiaNaoControlaAlmoxarifadoFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.naocontrolaalmoxarifado.FecharDiaNaoControlaAlmoxarifadoPage;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class FecharDiaNaoControlaAlmoxarifadoTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;

    FecharDiaNaoControlaAlmoxarifadoFlows fecharDiaNaoControlaAlmoxarifadoFlows;
    FecharDiaNaoControlaAlmoxarifadoPage fecharDiaNaoControlaAlmoxarifadoPage;

    @Test(description = "Est-51")
    @Ignore
    public void RealizarFechamentoDia(){

        //Objects
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        fecharDiaNaoControlaAlmoxarifadoFlows = new FecharDiaNaoControlaAlmoxarifadoFlows();
        fecharDiaNaoControlaAlmoxarifadoPage = new FecharDiaNaoControlaAlmoxarifadoPage();


        //Routine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoFecharDiaEStoque();
        fecharDiaNaoControlaAlmoxarifadoFlows.aplicarFecharDia();


    }


}
